
#include <unistd.h>
#include <stdlib.h>

#include "debug.h"

#include "errors.h"

#include "distancelist.h"




DISTENT distancelist_newlist(void)
{
	DISTENT dent;

	dent=(DISTENT)malloc(sizeof(ll_distanceentry *));
	*dent=NULL;

	return dent;
}


int distancelist_addentry(DISTENT list,int distance,void *entry)
{
	ll_distanceentry *current,*newentry;

	newentry=(ll_distanceentry *)malloc(sizeof(ll_distanceentry));
	if (newentry==NULL)
		return ERR_OUTOFMEMORY;

	newentry->distance=distance;
	newentry->entry=entry;
	
	if (*list==NULL || distance<=(*list)->distance)
	{
		newentry->next=*list;
		*list=newentry;
		return 0;
	}


	current=*list;

	while (current!=NULL)
	{
		if (current->next==NULL || (current->next->distance)>=distance)
		{
			newentry->next=current->next;
			current->next=newentry;
			return 0;
		}
		current=current->next;
	}

	return ERR_UNREACHABLE;
}




int distancelist_clearlist(DISTENT list)
{
	ll_distanceentry *current,*next;

	current=*list;

	while (current!=NULL)
	{
		next=current->next;
		free(current);
		current=next;
	}
	*list=NULL;
	free(list);
	return 0;
}



