

#include <stdlib.h>

#include "debug.h"

#include "errors.h"
#include "protocol.h"
#include "logic.h"
#include "bases.h"
#include "packages.h"


int packages_addpackage(ll_packages **plist,int packageid,int playerid, int weight,int x,int y, int to_x,int to_y);
int packages_removepackage(ll_packages **plist,int packageid);


ll_packages *pack_totallist=NULL;
ll_packages *pack_mylist=NULL;




/*   Self list */
/* I picked up a package */
/* I dropped a package */


/*   Total list */
/* I saw a package */
/* Someone dropped a package */
/* Someone picked up a package */



/* Have deliverable packages? */
	/* Which packages for here? */
	/* Which direction to deliver closest package? */

/* Any prime packages we know of? */
	/* Which direction to pick up best package? */


ll_packages *packages_total_getlist(void)
{
	return pack_totallist;
}

ll_packages *packages_self_getlist(void)
{
	return pack_mylist;
}

int packages_total_countdeliverable(int x,int y)
{
	int rval;
	ll_packages *current;
	


	rval=0;
	current=pack_totallist;

	while (current!=NULL)
	{
		if (current->holdingplayer==-1 && current->x==x && current->y==y)
			rval++;
		current=current->next;
	}
	return rval;
}

int packages_total_getweight(int packageid)
{
	ll_packages *search;

	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
	{
		return -1;
	}

	return search->weight;
}

int packages_total_removeall(int x,int y)
{
	ll_packages *scan,*next;

	scan=pack_totallist;

	while (scan!=NULL)
	{
		next=scan->next;
		if (scan->x==x && scan->y==y && scan->holdingplayer==-1)
			packages_total_removepackage(scan->packageid);
		scan=next;
	}
	return 0;
}


int packages_total_sawlist(ll_packagelist *plist,int x,int y)
{
	int rval;

	/* Remove all packages at this location, we'll readd the real ones in a moment */
	rval=packages_total_removeall(x,y);
	if (FAILURE(rval))
		return rval;

	if (plist==NULL)
	{
		/* Any packages recorded at this location are delivered.. */
		return 0;
	}

	while (plist!=NULL)
	{
		rval=packages_total_addpackage(plist->packageid,-1,plist->weight,x,y,plist->x,plist->y);
		if (FAILURE(rval))
			return rval;
		plist=plist->next;
	}

	
	rval=base_confirmbase(x,y);
	if (FAILURE(rval))
		return rval;

	return 0;
}



int packages_self_havepackages(void)
{
	if (pack_mylist!=NULL)
		return 1;
	return 0;
}

int packages_self_pickedup(int packageid)
{
	ll_packages *search;



	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
	{
		/* this is a new package */
		DEBUG_PRINT("Warning!  New package on pickup.  Should have been seen on previous turn.\n");
		return packages_total_addpackage(packageid,-1,-1,-1,-1,-1,-1);
	}

	return packages_self_addpackage(packageid,-2,search->weight,search->x,search->y,search->destx,search->desty);

}


int packages_self_dropped(int packageid,int x,int y)
{
	ll_packages *search;


	packages_self_removepackage(packageid);

	

	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
	{
		/* this is a new package */
		DEBUG_PRINT("Warning!  New package on dropoff.  Should have been seen on previous turns!\n");
		return 0;
	}

	if (x==search->destx && y==search->desty)
		ginfo.my_score+=search->weight;

	return 0;
}


int packages_total_saw(int packageid,int weight,int to_x,int to_y,int x,int y)
{
	ll_packages *search;

	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
		/* this is a new package */
		return packages_total_addpackage(packageid,-1,weight,x,y,to_x,to_y);

	/* Existing package, update info */
	search->holdingplayer=-1;
	search->weight=weight;
	search->destx=to_x;
	search->desty=to_y;
	search->x=x;
	search->y=y;

	return 0;




}

int packages_total_dropped(int packageid,int x,int y)
{
	ll_packages *search;

	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
		/* this is a new package */
		return packages_total_addpackage(packageid,-1,-1,x,y,-1,-1);

	/* Existing package, update info */
	search->holdingplayer=-1;
	search->x=x;
	search->y=y;

	if (search->x==search->destx && search->y==search->desty)
		return packages_total_removepackage(packageid); /* delivered */

	return 0;

}


int packages_total_pickedup(int packageid,int playerid)
{
	ll_packages *search;

	search=pack_totallist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}

	if (search==NULL)
		/* this is a new package */
		return packages_total_addpackage(packageid,playerid,-1,-1,-1,-1,-1);

	/* Existing package, update info */
	search->holdingplayer=playerid;
	search->x=-1;
	search->y=-1;

	return 0;
}


int packages_total_addpackage(int packageid,int playerid, int weight,int x,int y, int to_x,int to_y)
{
	return packages_addpackage(&pack_totallist,packageid,playerid,weight,x,y,to_x,to_y);
}

int packages_total_removepackage(int packageid)
{
	return packages_removepackage(&pack_totallist,packageid);
}


int packages_self_addpackage(int packageid,int playerid, int weight,int x,int y, int to_x,int to_y)
{
	return packages_addpackage(&pack_mylist,packageid,playerid,weight,x,y,to_x,to_y);
}

int packages_self_removepackage(int packageid)
{
	return packages_removepackage(&pack_mylist,packageid);
}


int packages_addpackage(ll_packages **plist,int packageid,int playerid, int weight,int x,int y, int to_x,int to_y)
{
	ll_packages *newentry;


	newentry=(ll_packages *)malloc(sizeof(ll_packages));

	if (newentry==NULL)
		return ERR_OUTOFMEMORY;

	newentry->packageid=packageid;
	newentry->holdingplayer=playerid;
	newentry->weight=weight;
	newentry->destx=to_x;
	newentry->desty=to_y;
	newentry->x=x;
	newentry->y=y;

	newentry->next=*plist;
	newentry->prev=NULL;

	if ((*plist)!=NULL)
		(*plist)->prev=newentry;

	(*plist)=newentry;

	return 0;
}

int packages_removepackage(ll_packages **plist,int packageid)
{
	ll_packages *search;

	search=*plist;

	while (search!=NULL)
	{
		if (search->packageid==packageid)
			break;
		search=search->next;
	}
	if (search==NULL)
		return 0;

	if (search->next!=NULL)
		(search->next)->prev=search->prev;
	if (search->prev!=NULL)
		(search->prev)->next=search->next;

	if (*plist==search)
		*plist=search->next;

	free(search);

	return 0;
}



