

#include <unistd.h>
#include <stdlib.h>

#include "debug.h"

#include "errors.h"
#include "protocol.h"
#include "logic.h"
#include "players.h"



ll_player *playerlist=NULL;



ll_player *player_getlist(void)
{
	return playerlist;
}


int player_position(int playernumber,int x,int y)
{
	ll_player *search;


	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.playerid==playernumber)
			break;
		search=search->next;
	}

	if (search==NULL)
	{
		search=(ll_player *)malloc(sizeof(ll_player));

		if (search==NULL)
			return ERR_OUTOFMEMORY;

		search->data.playerid=playernumber;
		search->next=playerlist;
		playerlist=search;
	}

	search->data.x=x;
	search->data.y=y;
	search->data.lastturnseen=ginfo.turn;


	return 0;

}


int player_moved(int playernumber,int direction)
{
	ll_player *search;

	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.playerid==playernumber)
		{
			switch (direction)
			{
			case DIRECTION_N:
				(search->data.y)++;
				break;
			case DIRECTION_S:
				(search->data.y)--;
				break;
			case DIRECTION_E:
				(search->data.x)++;
				break;
			case DIRECTION_W:
				(search->data.x)--;
				break;
			}

			search->data.lastturnseen=ginfo.turn;
			return 0;
		}
		search=search->next;
	}
	
	DEBUG_PRINT("Warning!  Player moved without an initial position!\n");
	return 0;
}

int player_seen(int playernumber)
{
	ll_player *search;

	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.playerid==playernumber)
		{
			search->data.lastturnseen=ginfo.turn;
			return 0;
		}
		search=search->next;
	}
	
	DEBUG_PRINT("Warning!  Player seen without an initial position!\n");
	return 0;
}

int player_exists(int playernumber)
{
	ll_player *search;

	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.playerid==playernumber)
			return 1;
		search=search->next;
	}
	return 0;
}


int player_getposition(int playernumber,int *x,int *y)
{
	ll_player *search;

	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.playerid==playernumber)
		{
			*x=search->data.x;
			*y=search->data.y;
			return 1;
		}
		search=search->next;
	}
	return 0;
}


int player_at(int x,int y)
{
	ll_player *search;

	search=playerlist;

	while (search!=NULL)
	{
		if (search->data.x==x && search->data.y==y && search->data.lastturnseen==ginfo.turn)
		{
			return search->data.playerid;
		}
		search=search->next;
	}
	return 0;
}


